/*
* Placeholder PetaLinux user application.
*
* Replace this with your application code

* Copyright (C) 2013 - 2016  Xilinx, Inc.  All rights reserved.
*
* Permission is hereby granted, free of charge, to any person
* obtaining a copy of this software and associated documentation
* files (the "Software"), to deal in the Software without restriction,
* including without limitation the rights to use, copy, modify, merge,
* publish, distribute, sublicense, and/or sell copies of the Software,
* and to permit persons to whom the Software is furnished to do so,
* subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included
* in all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
* IN NO EVENT SHALL XILINX  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
* CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
* Except as contained in this notice, the name of the Xilinx shall not be used
* in advertising or otherwise to promote the sale, use or other dealings in this
* Software without prior written authorization from Xilinx.
*
*/

#include <sys/prctl.h>
#include <stdio.h>
#include <time.h>
#include <stdint.h>
#include <fstream>
#include <pthread.h>
#include <sched.h>
#include <iostream>
#include <tgmath.h> 

using namespace std;

#define NSEC 1000000000
#define MSEC 1000000

#define ITERATIONS 1000
#define POWER_OF_TENS   5
#define MIN_DELAY_NS 1000

float res[ITERATIONS];
  
int main(int argc , char ** argv)
{
    struct timespec spec , spec2 , spec_sleep ;
    spec_sleep.tv_sec = 0;
    std::ofstream outfile;
    
    /* set timer slack to 1 ns */
    prctl( PR_SET_TIMERSLACK , 1);
    
    outfile.open("nanosleep.csv", std::ios::trunc);
    
    for(int pot = 0; pot < POWER_OF_TENS; pot++){
        for(int factor = 2; factor <= 10; factor++){
            long delay = MIN_DELAY_NS * (pow(10,pot) * factor);
            std::cout << "Measuring delay " << delay << std::endl; 
            spec_sleep.tv_nsec = delay;
            for(int i = 0; i < ITERATIONS; i++){
                
                /* get current timestamp of real -time clock */
                clock_gettime ( CLOCK_REALTIME , &spec);
                /* sleep at least for the specified amount of time */
                nanosleep (& spec_sleep , NULL);
                /* get current timestamp again immediately after sleep */
                clock_gettime ( CLOCK_REALTIME , &spec2);
                
                long now_ts_begin = spec.tv_sec * NSEC + spec.tv_nsec;
                long now_ts_end = spec2.tv_sec * NSEC + spec2.tv_nsec;
                long ts_sleep_error = (now_ts_end - now_ts_begin) - delay;
                
                res[i] = ts_sleep_error;
                
            }
            
            /* Write results to file */
            outfile << delay;
            for(int i = 0; i < ITERATIONS; i++){
                outfile << "," << res[i];
            }
            outfile << std::endl;
        }
    }
    
    outfile.close ();
            
    return 0;
}

