/*
* Copyright (C) 2013 - 2016  Xilinx, Inc.  All rights reserved.
*
* Permission is hereby granted, free of charge, to any person
* obtaining a copy of this software and associated documentation
* files (the "Software"), to deal in the Software without restriction,
* including without limitation the rights to use, copy, modify, merge,
* publish, distribute, sublicense, and/or sell copies of the Software,
* and to permit persons to whom the Software is furnished to do so,
* subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included
* in all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
* IN NO EVENT SHALL XILINX  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
* CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
* Except as contained in this notice, the name of the Xilinx shall not be used
* in advertising or otherwise to promote the sale, use or other dealings in this
* Software without prior written authorization from Xilinx.
*
*/

#include <stdio.h>
#include<string.h> //memset
#include <stdlib.h>
#include<arpa/inet.h>
#include<sys/socket.h>

#define BUFLEN 4	//Max length of buffer
#define PORT 4000	//The port on which to listen for incoming data

int main(int argc, char **argv)
{
	struct sockaddr_in si_me, si_other;	
	int s, i, slen = sizeof(si_other) , recv_len;
	char buf[BUFLEN];
	
	printf("Hello World from Stress-ng remote app!\n");
	
	//create a UDP socket
	if ((s=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1)
		exit(2);
	
	// zero out the structure
	memset((char *) &si_me, 0, sizeof(si_me));
	
	si_me.sin_family = AF_INET;
	si_me.sin_port = htons(PORT);
	si_me.sin_addr.s_addr = htonl(INADDR_ANY);
	
	//bind socket to port
	if( bind(s , (struct sockaddr*)&si_me, sizeof(si_me) ) == -1)
		exit(1);
	
	//keep listening for data
	while(1)
	{		
		//try to receive some data, this is a blocking call
		if ((recv_len = recvfrom(s, buf, BUFLEN, 0, (struct sockaddr *) &si_other, &slen)) == -1)
			exit(3);
			
		if(recv_len > 0){
			switch(buf[0]){
				case 1:
					printf("Starting stress-ng with memcpy\n");
					system("chrt -r 1 taskset -c 2-3 stress-ng --memcpy 2 -t120s");
					break;
				case 2:
					printf("Starting stress-ng with memthrash\n");
					system("chrt -r 1 taskset -c 2-3 stress-ng --memthrash 2 -t120s");
					break;
				case 3:
					printf("Starting stress-ng with class memory\n");
					system("chrt -r 1 taskset -c 2-3 stress-ng --class memory --all 2 -t120s");
					break;
				case 4:
					printf("Starting stress-ng with matrix mulitply\n");
					system("chrt -r 1 taskset -c 2-3 stress-ng --matrix 2 -t120s");
					break;
				case 5:
					printf("Starting stress-ng with cpu\n");
					system("chrt -r 1 taskset -c 2-3 stress-ng --cpu-method all --all 2 -t120s");
					break;
				case 6:
					printf("Starting stress-ng with cpu\n");
					system("chrt -r 1 taskset -c 2-3 stress-ng --vm 2 -t120s");
					break;
				default:
					printf("Don't know what to do\n");
					break;
			}
		}
	}

	close(s);
	return 0;
}
