
#include <stdio.h> 
#include <netdb.h> 
#include <netinet/in.h> 
#include <stdlib.h> 
#include <string.h> 
#include <sys/socket.h> 
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>

#define SA struct sockaddr 

#define OBECT_SIZE 1024*1024
char largeObject[OBECT_SIZE];

static int readBlock(int socket, void*buffer, size_t size, size_t blockSize){
	size_t bytesLeft = size;
	size_t bytesRead = 0;

	if(blockSize == 0)
		blockSize = size;

	do{
		if(blockSize <= bytesLeft)
			bytesRead = read(socket, buffer, blockSize);
		else
			bytesRead = read(socket, buffer, bytesLeft);
		if(bytesRead < 0)
			return -1;
		bytesLeft -= bytesRead;
	}while(bytesLeft > 0);
}

static int writeBlock(int socket, void*buffer, size_t size, size_t blockSize){
	size_t bytesLeft = size;
	size_t bytesWritten = 0;

	if(blockSize == 0)
		blockSize = size;

	do{
		if(blockSize <= bytesLeft)
			bytesWritten = write(socket, buffer, blockSize);
		else
			bytesWritten = write(socket, buffer, bytesLeft);
		if(bytesWritten < 0)
			return -1;
		bytesLeft -= bytesWritten;
	}while(bytesLeft > 0);
}

int tcpTokenRing(int master, uint16_t port_in, uint16_t port_out, char *address_out, void *buffer, size_t size, size_t blockSize){
    int sockfd, connfd, peerfd, len; 
    struct sockaddr_in servaddr, client, peer;
    int bytesLeft, bytes;
        
    // assign IP, PORT 
    bzero(&servaddr, sizeof(servaddr)); 
    servaddr.sin_family = AF_INET; 
    servaddr.sin_addr.s_addr = htonl(INADDR_ANY); 
    servaddr.sin_port = htons(port_in); 

    bzero(&peer, sizeof(peer)); 
    peer.sin_family = AF_INET; 
    peer.sin_addr.s_addr = inet_addr(address_out); 
    peer.sin_port = htons(port_out); 

  
    // socket create and verification 
    sockfd = socket(AF_INET, SOCK_STREAM, 0); 
    peerfd = socket(AF_INET, SOCK_STREAM, 0);
    if (sockfd == -1 || peerfd == -1) { 
       return -1;
    } 

  
    // Binding newly created socket to given IP and verification 
    if ((bind(sockfd, (SA*)&servaddr, sizeof(servaddr))) != 0) { 
        return -2; 
    } 
 
    // Now server is ready to listen and verification 
    if ((listen(sockfd, 5)) != 0) { 
        return -3;
    }

    int tcp_maxseg;
    socklen_t tcp_maxseg_len = sizeof(tcp_maxseg);
    tcp_maxseg = 1452;
    if(setsockopt(sockfd, IPPROTO_TCP, TCP_MAXSEG, &tcp_maxseg, tcp_maxseg_len) < 0 ) {
           return -5;
    } 
 
    len = sizeof(client); 
  
    if(master == 0){
        // Accept the data packet from client and verification 
        connfd = accept(sockfd, (SA*)&client, &len); 
        if (connfd < 0) { 
            return -6;
        } 

        // connect the client socket to server socket 
        while (connect(peerfd, (SA*)&peer, sizeof(peer)) != 0) { 
            sleep(1); 
        } 
        
		const int tcp_disable_nagle = 1;
        socklen_t tcp_disable_nagle_len = sizeof(tcp_disable_nagle);
        if(setsockopt(connfd, IPPROTO_TCP, TCP_NODELAY, &tcp_disable_nagle, tcp_disable_nagle_len) < 0 ) {
               return -5;
        }
        if(setsockopt(peerfd, IPPROTO_TCP, TCP_NODELAY, &tcp_disable_nagle, tcp_disable_nagle_len) < 0 ) {
            return -5;
        }
        
        // infinite loop for chat 
        for (;;) { 
            if(readBlock(peerfd, buffer, size, blockSize) < 0)
        		return -7;
        	if(writeBlock(connfd, buffer, size, blockSize) < 0)
        		return -8;
        }
    } else {
        // connect the client socket to server socket 
        while (connect(peerfd, (SA*)&peer, sizeof(peer)) != 0) { 
            sleep(1); 
        } 
        // Accept the data packet from client and verification 
        connfd = accept(sockfd, (SA*)&client, &len); 
        if (connfd < 0) { 
            return -6;
        } 
        
		const int tcp_disable_nagle = 1;
        socklen_t tcp_disable_nagle_len = sizeof(tcp_disable_nagle);
        if(setsockopt(connfd, IPPROTO_TCP, TCP_NODELAY, &tcp_disable_nagle, tcp_disable_nagle_len) < 0 ) {
               return -5;
        }
        if(setsockopt(peerfd, IPPROTO_TCP, TCP_NODELAY, &tcp_disable_nagle, tcp_disable_nagle_len) < 0 ) {
            return -5;
        }
         
        // infinite loop for chat 
        for (;;) { 
            if(writeBlock(connfd, buffer, size, blockSize) < 0)
				return -8;
        	if(readBlock(peerfd, buffer, size, blockSize) < 0)
				return -7;
        } 
    }
  
    // After chatting close the socket 
    close(peerfd);
    close(sockfd); 
}

// Driver function 
int main(int argc, char *argv[]) 
{ 
    if (argc != 6) {
      printf("USAGE: tcp-tokenring <localPort> <remotePort> <remote-host> <master (1 or 0)> <blocksize>\n");
      exit(1);
    }
    int err = tcpTokenRing(atoi(argv[4]), atoi(argv[1]), atoi(argv[2]), argv[3], (void *)largeObject, OBECT_SIZE, atoi(argv[5]));
    printf("Error %d", err);
} 
